<?php

/*
 REBOOT 
 DESTRUCTION DE TOUT LE CONTENU DE /TMP
 v. 0.10 - 06/2009 - SPIP 1.9.2
 Patrick Kuchard - www.encyclopedie-incomplete.com
*/

if (!defined("_ECRIRE_INC_VERSION")) return;

include_spip('inc/presentation');
include_spip('inc/statistiques');

function exec_reboot_action(){

# elements spip
global 	$connect_statut,
		$connect_toutes_rubriques,
		$connect_id_auteur,
		$couleur_claire, $couleur_foncee;

#
# function requises ...
#
include_spip("inc/reboot_init");
include_spip('inc/affiche_blocs');

function _PRIVATE_presentation_taille_fichier($n){
  $c=1024;$i=0;$t=$n;
  while($c<$t && $i++<3) $t=$t/$c;
  if (0<$i) $t=sprintf('%01.2f',$t).' '.substr('KMG',$i-1,1);
  else $t.=' ';
  return $t.'o';
}

function _PRIVATE_get_dir_size($dir){
  return exec("du -sb ".$dir." | awk '{print $1}'");
}

function _PRIVATE_print_infos($filepointer, $filename, $type, $niveau){
  if($type=='R'){
    echo str_repeat('&nbsp;&nbsp;', $niveau).'&nbsp;&nbsp;&nbsp;&nbsp;<img src="'._DIR_IMG_REBOOT.'reboot_folder.png" align="middle">'.$filename.'<br />';
    fwrite($filepointer, str_repeat(' ', $niveau).'  +--['.$filename.']'.chr(13).chr(10));
  }else{
    echo str_repeat('&nbsp;&nbsp;', $niveau).'&nbsp;&nbsp;&nbsp;&nbsp;<img src="'._DIR_IMG_REBOOT.'reboot_file.png" align="middle">'.$filename.'<br />';
    fwrite($filepointer, str_repeat(' ', $niveau).'  +-- '.$filename.chr(13).chr(10));
  }
}

function _PRIVATE_delete_directory($dir,$methode,$niveau,$filepointer){
  if (!file_exists($dir)) return true;
  if (!is_dir($dir)){
    _PRIVATE_print_infos($filepointer, basename($dir), '', $niveau);
    return unlink($dir);
  }
  _PRIVATE_print_infos($filepointer, basename($dir), 'R', $niveau);
  foreach (scandir($dir) as $item) {
    if ($item == '.' || $item == '..') continue;
    if (!_PRIVATE_delete_directory($dir.'/'.$item,$methode,$niveau+1,$filepointer)) return false;
  }
  // _PRIVATE_print_infos($filepointer, $item, 'R', $niveau);
  if($methode == 'garde_structure'){
    return(true);
  }else{
    return rmdir($dir);
  }
}

# date jour courte sql spip
	$date_auj = date('Y-m-d');

// Against bad configurations
if (get_magic_quotes_gpc()){
    foreach ($_POST as $k=>$v){
        $_POST[$k] = stripslashes($v);
    }
}
// On rcupre ce qu'il y a  rcuprer
foreach ($_POST as $k=>$v){
 $_SESSION[$k] = $v;
}
foreach ($_GET as $k=>$v){
 $_SESSION[$k] = $v;
}

#
# affichage
#
$commencer_page = charger_fonction('commencer_page', 'inc');
echo $commencer_page(_T('reboot:reboot_titre'), "suivi", "reboot_pg");
echo "<a name='haut_page'></a>";

# Vrifier si Admin principal du site
if ($connect_statut != '0minirezo' OR !$connect_toutes_rubriques) {
	echo _T('avis_non_acces_page');
	echo fin_gauche(), fin_page();
	exit;
}

debut_gauche();

/*---------------------------------------------------------------------------*\
Affiche le logo reboot + gros titre + datestamp des serveurs PHP et MySQL
\*---------------------------------------------------------------------------*/

	debut_boite_info();
	$q=spip_query("SELECT DATE_FORMAT(NOW(),'%d/%m/%Y %H:%i') as date_serveur");
	$r=spip_fetch_array($q);
	$datetime_sql=$r['date_serveur'];

	$aff.= "<div style='float:left; margin-right:5px; min-height:55px;'>" 
		. "<img src='"._DIR_IMG_REBOOT."reboot_48.png' alt='reboot' />"
		. "</div>";

	$aff.= gros_titre(_T('reboot:reboot_titre'),'',false);

	$aff.= "<div style='clear:both;'></div>"
		. "<div class='cell_info verdana2'>"
		. "<img src='"._DIR_IMG_REBOOT."icon_php.png' align='absmiddle' title='"._T('reboot:date_serveur_php')."' />\n"
		. date('d/m/Y H:i')."<br />"
		. "<img src='"._DIR_IMG_REBOOT."icon_mysql.png' align='absmiddle' title='"._T('reboot:date_serveur_mysql')."' />\n"
		. $datetime_sql
		. "</div>"
		. "<p class='space_10'></p>";
	
  echo $aff;
	fin_boite_info();

/*---------------------------------------------------------------------------*\
Elements divers
\*---------------------------------------------------------------------------*/

	echo "<p class='space_10'></p>";
	debut_boite_info();
	echo _T('reboot:reboot_avertissement');
	fin_boite_info();

	echo "<p class='space_20'></p>";
	
	debut_boite_info();
	echo _T('reboot:reboot_repertoire_LOCAL');
  $handler = opendir(_DIR_LOCAL_REBOOT);
  $nb = 0;
  // keep going until all files in directory have been read
  while ( ($file = readdir($handler)) && ($nb<20) ) {
        // si $file n'est pas ce repertoire lui mme ou son parent
        // on l'ajoute dans le tableau
        if ($file != '.' && $file != '..'){
            $resultat['element'][$nb] = $file;
            $stats = stat(_DIR_LOCAL_REBOOT.'/'.$file);
            $resultat['size'][$nb] = $stats['size'];
            $resultat['mtime'][$nb] = date("Y-m-d @ H:i:s", $stats['mtime']);
            $nb++;
        }
  }
  closedir($handler);
  if( $nb == 0){
	   echo _T('reboot:reboot_repertoire_LOCAL_vide');
  }else{
    // un petit tri pour faire joli
    for($i=0; $i<$nb; $i++){
		  for($j=$i; $j<$nb; $j++){
		    if($resultat['element'][$i] > $resultat['element'][$j]){
		      $temp = $resultat['element'][$i];
		      $resultat['element'][$i] = $resultat['element'][$j];
		      $resultat['element'][$j] = $temp;
		      $temp = $resultat['size'][$i];
		      $resultat['size'][$i] = $resultat['size'][$j];
		      $resultat['size'][$j] = $temp;
		      $temp = $resultat['mtime'][$i];
		      $resultat['mtime'][$i] = $resultat['mtime'][$j];
		      $resultat['mtime'][$j] = $temp;
        }
		  }      
    }
    echo _T('reboot:reboot_repertoire_LOCAL_plein').'<br />';
    for($i=0; $i<$nb; $i++){
      echo '<li>'.$resultat['element'][$i].'<br />&nbsp;&nbsp;&nbsp;<small>'._PRIVATE_presentation_taille_fichier($resultat['size'][$i]).' / &nbsp;&nbsp;'.$resultat['mtime'][$i].'</small></li>';
    }
    echo '<br /><li><a href="'.generer_url_ecrire("reboot_details").'" title="'._T('reboot:ouvrir_details').'"><img src="'._DIR_IMG_REBOOT.'page_search.png" align="middle" border="0"> '._T('reboot:lien_ouvrir_details').'</a></li>';
  }	
	fin_boite_info();

creer_colonne_droite();
echo "<p class='space_20'></p>";

/*---------------------------------------------------------------------------*\
atteindre page php info
\*---------------------------------------------------------------------------*/
	echo "<p class='space_10'></p>";
	debut_boite_info();
		echo "\n<a href='".generer_url_ecrire("info")."'>"._T('reboot:page_phpinfo')."</a>\n";
	fin_boite_info();


/*---------------------------------------------------------------------------*\
version de mysql du serveur :
\*---------------------------------------------------------------------------*/
	echo "<p class='space_10'></p>";
	debut_boite_info();
		$vers = mysql_query("select version()");
		$rep = mysql_fetch_array($vers);
		echo "MySQL v. ".$rep[0];
	fin_boite_info();

/*---------------------------------------------------------------------------*\
Patrick signe son mefait... si si !
\*---------------------------------------------------------------------------*/

echo "<p class='space_20'></p>";

	echo signature_plugin();




debut_droite();

/*---------------------------------------------------------------------------*\
Onglets pages sup.
\*---------------------------------------------------------------------------*/
	echo onglets_reboot(_request('exec'));

    // Cration d'un tableau qui va recevoir la liste des fichiers et dossiers  dtruire
    $resultat = array();   
    $nb = 0;
    $niveau = 0;
    $handler = opendir(_DIR_TMP_REBOOT);
    // keep going until all files in directory have been read
    while ($file = readdir($handler)) {
        // si $file n'est pas ce repertoire lui mme ou son parent
        // on l'ajoute dans le tableau
        if ($file != '.' && $file != '..'){
            $resultat['element'][$nb] = $file;
            $stats = stat(_DIR_TMP_REBOOT.'/'.$file);          
            if(($stats['mode'] & 0170000) == 040000){ // c'est un rpertoire ! 
              $resultat['type'][$nb] = 'R';
            }else{
              $resultat['type'][$nb] = '';
            }
            $nb++;
        }
    }
    closedir($handler);
    // un petit tri pour faire joli
    for($i=0; $i<$nb; $i++){
		  for($j=$i; $j<$nb; $j++){
		    if($resultat['element'][$i] > $resultat['element'][$j]){
		      $temp = $resultat['element'][$i];
		      $resultat['element'][$i] = $resultat['element'][$j];
		      $resultat['element'][$j] = $temp;
		      $temp = $resultat['type'][$i];
		      $resultat['type'][$i] = $resultat['type'][$j];
		      $resultat['type'][$j] = $temp;
        }
		  }      
    }
    if($_SESSION['destruct'] == 'go'){
	      debut_boite_info();
        $chrono_on = microtime(true);        
	      echo _T('reboot:debut_processus_destruction').'<small>('.date('Y-m-d @ H:i:s',$chrono_on).')</small><br /><br />';
        // echo '&nbsp;&nbsp;<img src="'._DIR_IMG_REBOOT.'reboot_folder.png" align="middle">reboot<br />';
	      // ouverture du fichier de log
        $fp = fopen(_DIR_LOCAL_REBOOT.'/'.date('Y-m-d_H-i-s').'.log','a');
        echo '<img src="'._DIR_IMG_REBOOT.'reboot_folder.png" align="middle">tmp<br />';
        fwrite($fp,'Delete Process - Begin : '.date('Y-m-d @ H:i:s',$chrono_on).chr(13).chr(10).chr(13).chr(10));
        if($_SESSION['work'] == 'garde_structure'){
          fwrite($fp,'Option : remove and unlink of files only, keeping structure of directories.'.chr(13).chr(10).chr(13).chr(10));          
        }else{
          fwrite($fp,'Option : remove and unlink of all files and directories.'.chr(13).chr(10).chr(13).chr(10));
        }
        // fwrite($fp,'+--[tmp]'.chr(13).chr(10).' +--[reboot]'.chr(13).chr(10));
        fwrite($fp,'+--[tmp]'.chr(13).chr(10));
        foreach( $_SESSION as $key => $value ){
          if( is_numeric($key) ){
            if($resultat['type'][$key] == 'R'){ // c'est un rpertoire !
              _PRIVATE_delete_directory(_DIR_TMP_REBOOT.'/'.$resultat['element'][$key],$_SESSION['work'],$niveau,$fp);                
            }else{
              unlink(_DIR_TMP_REBOOT.'/'.$resultat['element'][$key]);
              _PRIVATE_print_infos($fp, $resultat['element'][$key], '', $niveau);
            }
          }
       }
       fwrite($fp,chr(13).chr(10).chr(13).chr(10).'Delete Process - End : '.date('Y-m-d @ H:i:s',microtime(true)).chr(13).chr(10).'Time to Proceed : '.(microtime(true)-$chrono_on).' second(s).'.chr(13).chr(10));
       fclose($fp);
	     echo '<br /><br />'._T('reboot:fin_processus_destruction').'<small>('.date('Y-m-d @ H:i:s',$chrono_on).' - Time to proceed : '.(microtime(true)-$chrono_on).' second(s))</small><br /><br />';
	     fin_boite_info();
    }else{
	  debut_boite_info();
    echo _T('reboot:voulez_vous_vraiment_detruire').'<br /><br />';
    $aff = '<center><table border="0" width="50%">';
    foreach( $_SESSION as $key => $value ){
      if( is_numeric($key) ){
 			  $ifond = $ifond ^ 1;
			  $couleur = ($ifond) ? '#FFFFFF' : '#BBDDFF';
        $aff .= '<tr bgcolor="'.$couleur.'"><td width="30px;">';
        if($resultat['type'][$key] == 'R'){ // c'est un rpertoire !
          $aff .= '<img src="'._DIR_IMG_REBOOT.'reboot_folder.png">'; 
        }else{
          $aff .= '<img src="'._DIR_IMG_REBOOT.'reboot_file.png">';        
        }
        $aff .= '</td><td>'.$resultat['element'][$key].'</td></tr>';
      }
    }
    $aff .= '</table></center><br /><br />';
    echo $aff;
    if($_SESSION['work'] == 'garde_structure'){
      echo _T('reboot:structure_conservee').'<br /><br />';    
    }else{
      echo _T('reboot:structure_detruite').'<br /><br />';    
    }
	fin_boite_info();
    
	echo '<p class="space_10"></p>';

	debut_boite_info();
  echo '<form id="form_suite" name="form_suite" action="?exec=reboot_action">
        <input type="hidden" name="destruct" value="go"> 
        <input type="hidden" name="exec" value="reboot_action">
        <input type="hidden" name="work" value="'.$_SESSION['work'].'">
  <center><input onmouseover="this.style.border=\'2px dashed #878787\';"; onmouseout="this.style.border=\'0px\';" 
                                    type="submit" style="border:0px;
                                                        background: url('._DIR_IMG_REBOOT.'folder_remove_48.png) no-repeat;
                                                        width: 220px;
                                                        height: 50px;
                                                        "
      value="'._T('reboot:destruction_des_elements').'">
  </center><br /><br />';
  foreach( $_SESSION as $key => $value ){
    if( is_numeric($key) ){
      echo '<input type="hidden" name="'.$key.'" value="'.$value.'">';
    }
  }  
  echo '</form>';  
  
	fin_boite_info();
  }

# retour haut de page
echo bouton_retour_haut();

echo fin_gauche(), fin_page();

} // fin exec

?>
