<?php

/*
 REBOOT 
 DESTRUCTION DE TOUT LE CONTENU DE /TMP
 v. 0.10 - 06/2009 - SPIP 1.9.2
 Patrick Kuchard - www.encyclopedie-incomplete.com
*/

if (!defined("_ECRIRE_INC_VERSION")) return;

include_spip('inc/presentation');
include_spip('inc/statistiques');

function _PRIVATE_presentation_taille_fichier($n){
  $c=1024;$i=0;$t=$n;
  while($c<$t && $i++<3) $t=$t/$c;
  if (0<$i) $t=sprintf('%01.2f',$t).' '.substr('KMG',$i-1,1);
  else $t.=' ';
  return $t.'o';
}

function _PRIVATE_get_dir_size($dir){
  return exec("du -sb ".$dir." | awk '{print $1}'");
}

function _PRIVATE_clearDir($dossier) {
	$ouverture=@opendir($dossier);
	if (!$ouverture) return;
	while($fichier=readdir($ouverture)) {
		if ($fichier == '.' || $fichier == '..') continue;
			if (is_dir($dossier."/".$fichier)) {
				$r= _PRIVATE_clearDir($dossier."/".$fichier);
				if (!$r) return false;
			}
			else {
				$r=@unlink($dossier."/".$fichier);
				if (!$r) return false;
			}
	}
  closedir($ouverture);
  $r=@rmdir($dossier);
  if (!$r) return false;
	  return true;
}

function exec_reboot_remove_delete_reboot() {

# elements spip
global 	$connect_statut,
		$connect_toutes_rubriques,
		$connect_id_auteur,
		$couleur_claire, $couleur_foncee;

#
# function requises ...
#
include_spip("inc/reboot_init");
include_spip('inc/affiche_blocs');


# date jour courte sql spip
	$date_auj = date('Y-m-d');

#
# affichage
#
$commencer_page = charger_fonction('commencer_page', 'inc');
echo $commencer_page(_T('reboot:reboot_titre'), "suivi", "reboot_pg");
echo "<a name='haut_page'></a>";

# Vrifier si Admin principal du site
if ($connect_statut != '0minirezo' OR !$connect_toutes_rubriques) {
	echo _T('avis_non_acces_page');
	echo fin_gauche(), fin_page();
	exit;
}

debut_gauche();
/*---------------------------------------------------------------------------*\
Affiche le logo reboot + gros titre + datestamp des serveurs PHP et MySQL
\*---------------------------------------------------------------------------*/

	debut_boite_info();
	$q=spip_query("SELECT DATE_FORMAT(NOW(),'%d/%m/%Y %H:%i') as date_serveur");
	$r=spip_fetch_array($q);
	$datetime_sql=$r['date_serveur'];

	$aff.= "<div style='float:left; margin-right:5px; min-height:55px;'>" 
		. "<img src='"._DIR_IMG_REBOOT."reboot_48.png' alt='reboot' />"
		. "</div>";

	$aff.= gros_titre(_T('reboot:reboot_titre'),'',false);

	$aff.= "<div style='clear:both;'></div>"
		. "<div class='cell_info verdana2'>"
		. "<img src='"._DIR_IMG_REBOOT."icon_php.png' align='absmiddle' title='"._T('reboot:date_serveur_php')."' />\n"
		. date('d/m/Y H:i')."<br />"
		. "<img src='"._DIR_IMG_REBOOT."icon_mysql.png' align='absmiddle' title='"._T('reboot:date_serveur_mysql')."' />\n"
		. $datetime_sql
		. "</div>"
		. "<p class='space_10'></p>";
	
  echo $aff;
	fin_boite_info();

/*---------------------------------------------------------------------------*\
Elements divers
\*---------------------------------------------------------------------------*/

	echo "<p class='space_10'></p>";
	debut_boite_info();
	echo _T('reboot:reboot_avertissement');
	fin_boite_info();

creer_colonne_droite();
echo "<p class='space_20'></p>";

/*---------------------------------------------------------------------------*\
atteindre page php info
\*---------------------------------------------------------------------------*/
	echo "<p class='space_10'></p>";
	debut_boite_info();
		echo "\n<a href='".generer_url_ecrire("info")."'>"._T('reboot:page_phpinfo')."</a>\n";
	fin_boite_info();


/*---------------------------------------------------------------------------*\
version de mysql du serveur :
\*---------------------------------------------------------------------------*/
	echo "<p class='space_10'></p>";
	debut_boite_info();
		$vers = mysql_query("select version()");
		$rep = mysql_fetch_array($vers);
		echo "MySQL v. ".$rep[0];
	fin_boite_info();

/*---------------------------------------------------------------------------*\
Patrick signe son mefait... si si !
\*---------------------------------------------------------------------------*/

echo "<p class='space_20'></p>";

	echo signature_plugin();




debut_droite();

	echo onglets_reboot(_request('exec'));

	debut_boite_info();
  echo _T('reboot:procedure_remove_action_begin').'<br /><br />';
	fin_boite_info();

	echo '<p class="space_20"></p>';
  
	debut_boite_info();
  # destruction de /tmp/reboot
  echo _T('reboot:procedure_remove_action_delete_tmp_reboot_begin'); 
  $handler = opendir(_DIR_LOCAL_REBOOT);
  $nb = 0;
  // keep going until all files in directory have been read
  while ( $file = readdir($handler) ) {
        // si $file n'est pas ce repertoire lui mme ou son parent
        if ($file != '.' && $file != '..'){
            unlink(_DIR_LOCAL_REBOOT.'/'.$file);
            $nb++;
        }
  }
  closedir($handler);
  rmdir(_DIR_LOCAL_REBOOT);
  echo str_replace('%nb_files%', $nb, _T('reboot:procedure_remove_action_delete_tmp_reboot_end').'<br />'); 

  # destruction de /plugins/reboot
  echo _T('reboot:procedure_remove_action_delete_plugin_reboot_begin'); 
  if(_PRIVATE_clearDir(_DIR_REMOVE_REBOOT)){ // tout est OK
    echo _T('reboot:procedure_remove_action_delete_plugin_reboot_end').'<br />';   
  }else{ // Quelque chose n'a pas pu tre effac !!!
    echo _T('reboot:procedure_remove_action_delete_plugin_reboot_problem').'<br />';     
  }	
  # destruction des mta-donnes
  echo _T('reboot:procedure_remove_action_delete_meta_reboot_begin'); 
	effacer_meta('reboot');
  echo _T('reboot:procedure_remove_action_delete_meta_reboot_end').'<br />'; 
	fin_boite_info();

	echo '<p class="space_20"></p>';

	debut_boite_info();
  echo _T('reboot:procedure_remove_action_end').'<br /><br />';
	fin_boite_info();

# retour haut de page
echo bouton_retour_haut();

echo fin_gauche(), fin_page();

} // fin exec

?>
